<div id="header">
  <app-header></app-header>
</div>
<div class="container-fluid">
  <div id="content-wrapper" class="d-flex flex-row">
    <div id="sidebar"><app-sidebar></app-sidebar></div>
    <div id="main-container-gestionnaire-roles" class="container-fluid d-flex flex-column">
      <div id="title-container" class="container-fluid d-flex justify-content-between align-items-center p-4">
        <div class="dashboard-title d-flex flex-row align-items-center  p-5">
          <span><h1>GESTIONNAIRE DE FONCTIONNALITES</h1></span>
        </div>
        <app-add-fonctionnalite-popup></app-add-fonctionnalite-popup>
      </div>
      <div class="accordion accordion-flush" id="accordionFlushExample">
        <div class="accordion-item "
             *ngFor="let fonctionnalite of fonctionnalites; index as index "
             id="{{ fonctionnalite.id }}">
          <h2 class="accordion-header" id="flush-heading{{ fonctionnalite.id }}">
            <button class="accordion-button collapsed d-flex flex-row justify-content-between align-items-center "
                    type="button" data-bs-toggle="collapse"
                    [attr.data-bs-target]="'#flush-collapse' +
                    fonctionnalite.id " aria-expanded="false"
                    [attr.aria-controls]="'flush-collapse' +
                    fonctionnalite.id ">
              <div class="d-flex flex-row flex-grow-1 d-flex align-items-center">
                <span *ngIf="fonctionnalite.priorite && fonctionnalite.priorite == 1" class="priorite status d-flex align-items-center" (click)="onSetPriorite($event, fonctionnalite)">urgent</span>
                <span *ngIf="fonctionnalite.priorite && fonctionnalite.priorite == 2" class="priorite status d-flex align-items-center" (click)="onSetPriorite($event, fonctionnalite)">important</span>
                <span *ngIf="fonctionnalite.priorite && fonctionnalite.priorite == 3" class="priorite status d-flex align-items-center" (click)="onSetPriorite($event, fonctionnalite)">standard</span>
                <span *ngIf="fonctionnalite.priorite && fonctionnalite.priorite == 4" class="priorite status d-flex align-items-center" (click)="onSetPriorite($event, fonctionnalite)">optionnel</span>
                <span *ngIf="!fonctionnalite.priorite" class="priorite status d-flex align-items-center" (click)="onSetPriorite($event, fonctionnalite)">indéterminée</span>
                <span *ngIf="fonctionnalite.periodicite" class="periodicite status d-flex align-items-center" (click)="onSetPeriodicite($event, fonctionnalite)">{{ fonctionnalite.periodicite }} mois</span>
                <span *ngIf="!fonctionnalite.periodicite" class="periodicite status d-flex align-items-center" (click)="onSetPeriodicite($event, fonctionnalite)">indéterminée</span>
                <span *ngIf="!fonctionnalite.archive" class="actif status d-flex align-items-center" (click)="onDelete($event, fonctionnalite)">actif</span>
                <span *ngIf="fonctionnalite.archive" class="inactif status d-flex align-items-center" (click)="onDelete($event, fonctionnalite)">inactif</span>
                <!--<span class="plan-title d-flex align-items-center">{{ (plan.nom.length>25)? (plan.nom | slice:0:25)+'...':(plan.nom) }}</span>-->
                <span class="plan-title d-flex align-items-center">{{ fonctionnalite.nom }}</span>
              </div>
              <div>
                <span class="edit" (click)="onClick($event, fonctionnalite)">
                  <i class="fa-solid fa-pen" aria-hidden="true"></i>
                </span>
              </div>
            </button>
          </h2>
          <div id="flush-collapse{{ fonctionnalite.id }}" class="accordion-collapse collapse"
               [attr.aria-labelledby]="'flush-heading' +
               fonctionnalite.id "
               data-bs-parent="#accordionFlushExample">
            <div class="accordion-body ">
              <h3>DETAILS</h3>
              <h4>{{ fonctionnalite.nom }} - <span>{{ groupe.nom }}</span></h4>
              <p style="white-space: pre-wrap;">{{ fonctionnalite.details }}</p>
            </div>
            <div class="accordion-body-bottom ">
              <h3>RESULTAT ATTENDU</h3>
              <p style="white-space: pre-wrap;">{{ fonctionnalite.resultatAttendu }}</p>
              <h3>SCENARIO</h3>
              <p style="white-space: pre-wrap;">{{ fonctionnalite.scenario }}</p>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<!-- modal -->
<!-- Modal EDIT fonctionnalite-->
<div class="modal" id="myModal" [style.display]="showModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Détails de la fonctionnalité : {{editFonctionnalite?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('editModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body" *ngIf="editFonctionnalite">
        <form #editForm="ngForm" >
          <div class="form-group">
            <input
                   type="hidden"
                   ngModel="{{editFonctionnalite?.id}}"
                   name="id"
                   id="id"
            />
            <input
                   type="hidden"
                   ngModel="{{editFonctionnalite?.groupe_fonctionnalites_groupe_id}}"
                   id="groupe_fonctionnalites_groupe_id"
                   name="groupe_fonctionnalites_groupe_id"
            />
            <label class="mb-1" for="nom">Intitulé</label>
            <input
                   type="text"
                   [(ngModel)]="editFonctionnalite.nom"
                   id="nom"
                   name="nom"
                   class="form-control mb-2"
            />
          </div>
          <div class="form-group">
            <label class="mb-1" for="details">Détails</label>
            <textarea
                      class="form-control mb-2"
                      ngModel="{{editFonctionnalite?.details}}"
                      id="details"
                      name="details"
            ></textarea>
          </div>
          <div class="form-group">
            <label class="mb-1" for="resultatAttendu">Résultat Attendu</label>
            <textarea
              class="form-control mb-2"
              ngModel="{{editFonctionnalite?.resultatAttendu}}"
              id="resultatAttendu"
              name="resultatAttendu"
            ></textarea>
          </div>
          <div class="form-group">
            <label class="mb-1" for="scenario">Scenario</label>
            <textarea
              class="form-control mb-2"
              ngModel="{{editFonctionnalite?.scenario}}"
              id="scenario"
              name="scenario"
            ></textarea>
          </div>
          <div class="form-group">
            <label class="mb-1 w-100" for="periodicite" >Périodicité</label>
            <select ngModel="{{editFonctionnalite?.periodicite}}"
                    name="periodicite"
                    id="periodicite"
                    class="w-100"
            >
              <option value=1
                      [selected]="editFonctionnalite?.periodicite == 1"
              >1 mois</option>
              <option
                value=2
                [selected]="editFonctionnalite?.periodicite == 2"
              >2 mois</option>
              <option
                value=3
                [selected]="editFonctionnalite?.periodicite == 3"
              >3 mois</option>
              <option
                value=4
                [selected]="editFonctionnalite?.periodicite == 4"
              >4 mois</option>
              <option
                value=5
                [selected]="editFonctionnalite?.periodicite == 5"
              >5 mois</option>
              <option
                value=6
                [selected]="editFonctionnalite?.periodicite == 6"
              >6 mois</option>
              <option
                value=7
                [selected]="editFonctionnalite?.periodicite == 7"
              >7 mois</option>
              <option
                value=8
                [selected]="editFonctionnalite?.periodicite === 8"
              >8 mois</option>
              <option
                value=9
                [selected]="editFonctionnalite?.periodicite == 9"
              >9 mois</option>
              <option
                value=10
                [selected]="editFonctionnalite?.periodicite == 10"
              >10 mois</option>
              <option
                value=11
                [selected]="editFonctionnalite?.periodicite == 11"
              >11 mois</option>
              <option
                value=12
                [selected]="editFonctionnalite?.periodicite == 12"
              >12 mois</option>
            </select>
          </div>
          <div class="form-group">
            <label class="mb-1 w-100" for="priorite">Priorité</label>
            <select ngModel="{{editFonctionnalite?.priorite}}"
                    name="priorite"
                    id="priorite"
                    class="w-100"
            >
              <option value=1
                      [selected]="editFonctionnalite?.priorite === 1"
              >urgent</option>
              <option
                value=2
                [selected]="editFonctionnalite?.priorite === 2"
              >important</option>
              <option
                value=3
                [selected]="editFonctionnalite?.priorite === 3"
              >standard</option>
              <option
                value=4
                [selected]="editFonctionnalite?.priorite === 4"
              >optionnel</option>
            </select>
          </div>
          <div class="form-group">
            <label class="mb-1 w-100" for="archive" >Status</label>
            <select ngModel="{{editFonctionnalite?.archive}}"
                    name="archive"
                    id="archive"
                    class="w-100"
            >
              <option value="false"
                      [selected]="editFonctionnalite?.archive === false"
              >actif</option>
              <option
                      value="true"
                      [selected]="editFonctionnalite?.archive === true"
              >inactif</option>
            </select>
          </div>
          <div class="mt-3 mb-2">
            <button class="btn btn-primary w-100" (click)="onSubmit(editForm.value)" [disabled]="editForm.invalid">Sauvegarder</button>
          </div>
          <div class="mt-2 mb-2">
            <button class="btn btn-secondary w-100" type="reset" (click)="hide('editModal')">Annuler</button>
          </div>
        </form>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal DELETE Plan-->
<div class="modal" id="deleteModal" [style.display]="showDeleteModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Archiver : {{deleteFonctionnalite?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('deleteModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <div class="form-group">
          <p *ngIf="deleteFonctionnalite?.archive == true" class="mt-3 mb-5" >Vous êtes sur le point d'activer la fonctionnalité {{deleteFonctionnalite?.nom}}. <br/><br/>
            Êtes-vous sûr.e de vouloir continuer ?</p>
          <p *ngIf="deleteFonctionnalite?.archive == false" class="mt-3 mb-5" >Vous êtes sur le point de désactiver la fonctionnalité {{deleteFonctionnalite?.nom}}. <br/><br/>
            Êtes-vous sûr.e de vouloir continuer ?</p>
        </div>
          <div class="mt-3 mb-2">
            <button *ngIf="deleteFonctionnalite?.archive == true" class="btn btn-danger w-100" (click)="onArchiveFonctionnalite(deleteFonctionnalite)" data-dismiss="modal">Activer</button>
            <button *ngIf="deleteFonctionnalite?.archive == false" class="btn btn-danger w-100" (click)="onArchiveFonctionnalite(deleteFonctionnalite)" data-dismiss="modal">Désactiver</button>
          </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal SHOW PERIODICITE Plan-->
<div class="modal" id="setPeriodiciteModal" [style.display]="showPeriodiciteModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Définir la périodicité : {{setPeriodicite?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('setPeriodiciteModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #periodiciteForm="ngForm" >
          <div class="form-group">
            <label class="mb-1 me-2" for="periodicite">Périodicité :</label>
            <select ngModel="{{setPeriodicite?.periodicite}}"
                    name="periodicite"
                    id="periodicite"
            >
              <option value=1
                      [selected]="setPeriodicite?.periodicite == 1"
              >1 mois</option>
              <option
                value=2
                [selected]="setPeriodicite?.periodicite == 2"
              >2 mois</option>
              <option
                value=3
                [selected]="setPeriodicite?.periodicite == 3"
              >3 mois</option>
              <option
                value=4
                [selected]="setPeriodicite?.periodicite == 4"
              >4 mois</option>
              <option
                value=5
                [selected]="setPeriodicite?.periodicite == 5"
              >5 mois</option>
              <option
                value=6
                [selected]="setPeriodicite?.periodicite == 6"
              >6 mois</option>
              <option
                value=7
                [selected]="setPeriodicite?.periodicite == 7"
              >7 mois</option>
              <option
                value=8
                [selected]="setPeriodicite?.periodicite === 8"
              >8 mois</option>
              <option
                value=9
                [selected]="setPeriodicite?.periodicite == 9"
              >9 mois</option>
              <option
                value=10
                [selected]="setPeriodicite?.periodicite == 10"
              >10 mois</option>
              <option
                value=11
                [selected]="setPeriodicite?.periodicite == 11"
              >11 mois</option>
              <option
                value=12
                [selected]="setPeriodicite?.periodicite == 12"
              >12 mois</option>
            </select>
          </div>
        </form>
        <div class="mt-3 mb-2">
          <button class="btn btn-primary w-100" (click)="onModifyPeriodicite(periodiciteForm.value)" data-dismiss="modal">Enregistrer</button>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal SHOW PRIORITE Plan-->
<div class="modal" id="setPrioriteModal" [style.display]="showPrioriteModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Définir la priorité : {{setPriorite?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('setPrioriteModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #prioriteForm="ngForm" >
          <div class="form-group">
            <label class="mb-1 me-2" for="priorite">Priorité :</label>
            <select ngModel="{{setPriorite?.priorite}}"
                    name="priorite"
                    id="priorite"
            >
              <option value="1"
                      [selected]="setPriorite?.priorite == 1"
              >urgent</option>
              <option
                value="2"
                [selected]="setPriorite?.priorite == 2"
              >important</option>
              <option
                value="3"
                [selected]="setPriorite?.priorite == 3"
              >standard</option>
              <option
                value="4"
                [selected]="setPriorite?.priorite == 4"
              >optionnel</option>
            </select>
          </div>
        </form>
        <div class="mt-3 mb-2">
          <button class="btn btn-primary w-100" (click)="onModifyPriorite(prioriteForm.value)" data-dismiss="modal">Enregistrer</button>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>
